=== debian/changelog ===
sysdig (0.27.1-0.3build1) jammy; urgency=medium

  * No-change rebuild for libtbb soname change.

 -- Matthias Klose <doko@ubuntu.com>  Wed, 09 Mar 2022 10:04:11 +0100

sysdig (0.27.1-0.3) unstable; urgency=medium

  * Non-maintainer upload
  * Fix -Wformat-security error (Closes: #997171)

 -- Dima Kogan <dkogan@debian.org>  Sun, 06 Feb 2022 22:30:59 -0800

sysdig (0.27.1-0.2) unstable; urgency=medium

  * Non-maintainer upload
  * Fix FTBFS on armhf. Thanks to Paolo Pisati for the patch. (Closes: #966479)

 -- Dima Kogan <dkogan@debian.org>  Sun, 07 Mar 2021 20:55:11 -0800

sysdig (0.27.1-0.1) unstable; urgency=medium

  * Non-maintainer upload
  * New upstream version (Closes: #976053)

 -- Dima Kogan <dkogan@debian.org>  Sat, 30 Jan 2021 17:55:30 -0800
